'use strict';

var _apply = require('./src/apply');

var _apply2 = _interopRequireDefault(_apply);

var _validateOptions = require('./src/validateOptions');

var _validateOptions2 = _interopRequireDefault(_validateOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Instantiates the plugin
 *
 * @param {Object} options           The options
 */
/**
 * CarteBlanche Webpack Plugin
 *
 * The plugin is instantiated and the emitted carte-blanche.html file is
 * generated here.
 */

var id = -1;
function CarteBlanche(options) {
  // Allow for multiple instances of the plugin
  this.id = ++id;
  // Default and validate the options
  (0, _validateOptions2.default)(options || {});
  this.options = options;
}

// This method is the meat of our plugin, it does most of the work
CarteBlanche.prototype.apply = _apply2.default;

module.exports = CarteBlanche;