'use strict';

var _loaderUtils = require('loader-utils');

var _loaderUtils2 = _interopRequireDefault(_loaderUtils);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable max-len */


module.exports = function dynamicResolve() {
  this.cacheable();
  var query = _loaderUtils2.default.parseQuery(this.query);
  var filter = query.filter;
  // TODO check on windows
  var absoluteComponentRoot = _path2.default.resolve(query.context, query.componentRoot);
  var relativeComponentRoot = _path2.default.relative(query.context, absoluteComponentRoot);

  var loaderMapping = {
    compiledComponent: '',
    meta: '!!' + require.resolve('./loaders/plugins-loader.js') + '?dest="' + query.dest + '"&commonsChunkFilename="' + query.commonsChunkFilename + '"!',
    examples: require.resolve('./loaders/examples-loader.js') + '!'
  };

  var loaders = Object.keys(loaderMapping);

  // Add dynamics requires for every loaders
  loaders.forEach(function (loader) {
    loaderMapping[loader] = 'require.context(\'' + loaderMapping[loader] + absoluteComponentRoot + '\', true, ' + filter + ')';
  });

  return '\n    // Activate hot module replacement\n    module.hot && module.hot.accept();\n    // Dynamic webpack loading for every loader\n    var resources = {\n      ' + loaders.map(function (loader) {
    return '"' + loader + '":' + loaderMapping[loader];
  }) + ',\n    };\n    window.$INITIALIZE_COMPONENT_GUI._ressources = resources;\n    // The dynamic component files:\n    var componentFiles = resources[\'' + loaders[0] + '\'].keys();\n    // Gather all loader information for every loader\n    var components = {};\n    componentFiles.forEach(function(componentFile) {\n      var relativePath = componentFile.replace(/.\\//, \'' + relativeComponentRoot + '/\');\n      components[relativePath] = {};\n      Object.keys(resources).forEach(function(loader) {\n        components[relativePath][\'get\' + loader.substr(0, 1).toUpperCase() + loader.substr(1)] = function() {\n          return window.$INITIALIZE_COMPONENT_GUI._ressources[loader](componentFile);\n        };\n      });\n    });\n    window.$INITIALIZE_COMPONENT_GUI(components);\n   ';
};